######### SSO Configuration

map "$host" $saml_sp_entity_id {
  default "{{ saml_config.sp_entity_id }}";
}

map "$host" $saml_sp_acs_url {
  default "{{ saml_config.sp_acs_url }}";
}

map "$host" $saml_sp_request_binding {
  default "{{ saml_config.sp_request_binding }}";
}

map "$host" $saml_sp_sign_authn {
  default "{{ saml_config.sp_sign_authn }}";
}

map "$host" $saml_sp_signing_key {
  default "{{ saml_config.sp_signing_key }}";
}

map "$host" $saml_sp_decryption_key {
  default "{{ saml_config.sp_decryption_key }}";
}

map "$host" $saml_sp_force_authn {
  default "{{ saml_config.sp_force_authn }}";
}

map "$host" $saml_sp_nameid_format {
  default "{{ saml_config.sp_nameid_format }}";
}

map "$host" $saml_sp_relay_state {
  default "{{ saml_config.sp_relay_state }}";
}

map "$host" $saml_sp_want_signed_response {
  default "{{ saml_config.sp_want_signed_response }}";
}

map "$host" $saml_sp_want_signed_assertion {
  default "{{ saml_config.sp_want_signed_assertion }}";
}

map "$host" $saml_sp_want_encrypted_assertion {
  default "{{ saml_config.sp_want_encrypted_assertion }}";
}

map "$host" $saml_idp_entity_id {
  default "{{ saml_config.idp_entity_id }}";
}

map "$host" $saml_idp_sso_url {
  default "{{ saml_config.idp_sso_url }}";
}

map "$host" $saml_idp_verification_certificate {
  default "{{ saml_config.idp_verification_certificate }}";
}

######### SLO Configuration

map "$host" $saml_sp_slo_url {
  default "{{ saml_config.sp_slo_url }}";
}

map "$host" $saml_sp_slo_binding {
  default "{{ saml_config.sp_slo_binding }}";
}

map "$host" $saml_sp_sign_slo {
  default "{{ saml_config.sp_sign_slo }}";
}

map "$host" $saml_sp_want_signed_slo {
  default "{{ saml_config.sp_want_signed_slo }}";
}

map "$host" $saml_idp_slo_url {
  default "{{ saml_config.idp_slo_url }}";
}

map "$host" $saml_logout_landing_page {
  default "/_logout";
}

map $host $saml_cookie_flags {
  default "Path=/; SameSite=lax; HttpOnly; Secure;";
}

map $host $redirect_base {
  default "{{ saml_config.sp_redirect_base }}";
}

######### Shared memory zones that keep the SAML-related key-value databases

# Zone for storing AuthnRequest and LogoutRequest message identifiers (ID)
# to prevent replay attacks. (REQUIRED)
# Timeout determines how long the SP waits for a response from the IDP,
# i.e. how long the user authentication process can take.
keyval_zone zone=saml_request_id:1M                 state=/var/lib/nginx/state/saml_request_id.json                  timeout=5m;

# Zone for storing SAML Response message identifiers (ID) to prevent replay attacks. (REQUIRED)
# Timeout determines how long the SP keeps IDs to prevent reuse.
keyval_zone zone=saml_response_id:1M                state=/var/lib/nginx/state/saml_response_id.json                 timeout=1h;

# Zone for storing SAML session access information. (REQUIRED)
# Timeout determines how long the SP keeps session access decision (the session lifetime).
keyval_zone zone=saml_session_access:1M             state=/var/lib/nginx/state/saml_session_access.json              timeout=1h;

# Zone for storing SAML NameID values. (REQUIRED)
# Timeout determines how long the SP keeps NameID values. Must be equal to session lifetime.
keyval_zone zone=saml_name_id:1M                    state=/var/lib/nginx/state/saml_name_id.json                     timeout=1h;

# Zone for storing SAML NameID format values. (REQUIRED)
# Timeout determines how long the SP keeps NameID format values. Must be equal to session lifetime.
keyval_zone zone=saml_name_id_format:1M             state=/var/lib/nginx/state/saml_name_id_format.json              timeout=1h;

# Zone for storing SAML SessionIndex values. (REQUIRED)
# Timeout determines how long the SP keeps SessionIndex values. Must be equal to session lifetime.
keyval_zone zone=saml_session_index:1M              state=/var/lib/nginx/state/saml_session_index.json               timeout=1h;

# Zone for storing SAML AuthnContextClassRef values. (REQUIRED)
# Timeout determines how long the SP keeps AuthnContextClassRef values. Must be equal to session lifetime.
keyval_zone zone=saml_authn_context_class_ref:1M    state=/var/lib/nginx/state/saml_authn_context_class_ref.json     timeout=1h;

# Zones for storing SAML attributes values. (OPTIONAL)
# Timeout determines how long the SP keeps attributes values. Must be equal to session lifetime.
keyval_zone zone=saml_attrib_uid:1M                 state=/var/lib/nginx/state/saml_attrib_uid.json                  timeout=1h;
keyval_zone zone=saml_attrib_name:1M                state=/var/lib/nginx/state/saml_attrib_name.json                 timeout=1h;
keyval_zone zone=saml_attrib_memberOf:1M            state=/var/lib/nginx/state/saml_attrib_memberOf.json             timeout=1h;

######### SAML-related variables whose value is looked up by the key (session cookie) in the key-value database.

# Required:
keyval $saml_request_id     $saml_request_redeemed          zone=saml_request_id;               # SAML Request ID
keyval $saml_response_id    $saml_response_redeemed         zone=saml_response_id;              # SAML Response ID
keyval $cookie_auth_token   $saml_access_granted            zone=saml_session_access;           # SAML Access decision
keyval $cookie_auth_token   $saml_name_id                   zone=saml_name_id;                  # SAML NameID
keyval $cookie_auth_token   $saml_name_id_format            zone=saml_name_id_format;           # SAML NameIDFormat
keyval $cookie_auth_token   $saml_session_index             zone=saml_session_index;            # SAML SessionIndex
keyval $cookie_auth_token   $saml_authn_context_class_ref   zone=saml_authn_context_class_ref;  # SAML AuthnContextClassRef

# Optional:
keyval $cookie_auth_token   $saml_attrib_uid                zone=saml_attrib_uid;
keyval $cookie_auth_token   $saml_attrib_name               zone=saml_attrib_name;
keyval $cookie_auth_token   $saml_attrib_memberOf           zone=saml_attrib_memberOf;

######### Imports a module that implements SAML SSO and SLO functionality
js_import samlsp from scripts.d/saml_sp.js;
